<?php

include_once('../includes/global.php');
include_once('../includes/dbc.php');
include_once('import.php');

ShowPage();

if(!$User->Licence(LICENCE_ADMIN))
{
  echo('Nemáte oprávnění');
  ShowFooter();
  die();
}

function ShowInstructions()
{
  echo('<div>
  <h5>Návod:</h5>
  <ol><li>Pripojíme se pres SSH na server (wowpreklad.zdechov.net) napríklad pres prohram putty.exe nebo terminál v linuxu.</li>
<li>Nejprve je potreba získat zdrojová data. Není zapotrebí mít všechny typy textu.

  <ol style="list-style-type: lower-alpha">
  <li>SQL databázi UDB seženeme na fóru: http://udbforums.kicks-ass.net/index.php?board=5.0 , sobor rozbalíme a uložíme do adresáre "wowpreklad/source/císlo_verze/sql/"</li>
  <li>DBC soubory exportujeme prímo ze hry z souboru "World of Warcraft\Data\enGB\patch-enGB-2.MPQ" nebo z souboru s vyším císlem na konci. Export se provádí napríklad pomocí programu "MPQEditor.exe", který ke stažení v adresári "wowpreklad/download". DBC soubory jsou v MPQ souboru uloženy ve složce "DBFilesClient". Tyto soubory zkopírujte do složky "wowpreklad/source/císlo_verze/dbc/"</li>
  <li>LUA soubory exportujeme prímo ze hry z souboru "World of Warcraft\Data\enGB\patch-enGB-2.MPQ" nebo z souboru s vyším císlem na konci. Export se provádí napríklad pomocí programu "MPQEditor.exe", který ke stažení v adresári "wowpreklad/download". LUA soubory jsou v MPQ souboru uloženy ve složce "Interface\FrameXML" a složce "Interface\GlueXML". Soubory, které porebujeme se jmenují "GlobalString.lua" a "GlueString.lua". Tyto soubory zkopírujte do složky "wowpreklad/source/císlo_verze/lua/"</li></ol></li>
<li>Do databáze vložíme data o verzi, kterou se hodláme importovat do tabulky wow_client_verse. Pokud budeme importovat dbc soubory je nutné vložit zde strukturu dbc souboru. To lze provést napríklad pomocí programu "CBCUtil", který je také ke stažení v složce download. Tento program vytvorí soubory spustitelné v OpenOffice. Kde první rádek v tabulce je struktura dbc souboru. Typ "str" se zaznací jako "s", každý jiný typ se oznací písmenem "u". Struktura pak vypadá napríklad "usuuuuuuuuuuuu". Krome toho je zapotrebí do databáze poznacit císelné pozice textu, prní položka je 0. Z predchozího príkladu by pozice sloupce s textem byla 1.</li>
<li>V nastavení "wowpreklad/includes/config.php" nastavíme nejvyžší verzi na verzi, kterou hodláme importovat.</li>
<li>Až máme všechno pripraveno spustíme v konzoli script príkazem "php wowpreklad/import/cmd.php" kde jsou popsané možnosti paremetu s kterýma se tento script spoucí pro ruzné importy.</li>
<li>Po provedení importu je potreba nekolikrát spustit script na aktualizaci verze u prekladu. Je potreba ho prováde opakovane dokud nezmizí tecky oznacující že byly provedeny zmeny.</li>
</ol>');
}

function ShowImportGroup()
{
  global $Config;
  
  if(array_key_exists('id', $_GET)) 
  {
    echo('<div style="font-size: xx-small;">');
    
    $GroupId = (int)$_GET['id'];
    $Import = new Import();
    $Import->SetVersion($Config['Web']['GameVersion']);
    $Import->ImportGroup($GroupId);
  
    WriteLog('Plnění databáze', LOG_TYPE_MODERATOR);
    echo('</div>');
  } else echo('Nebylo zadáno id skupiny');
}

function ShowMenu()
{
  global $TranslationTree, $Database, $Config;
  
  echo('</div><div><strong>Import zdrojů:</strong></div>');
  
  echo('<div><a href="?action=instructions">Instrukce pro přípravu zdrojových souborů</a></div>');
  echo('<div><a href="?action=update_translated">Zaktualizovat verze přeložených</a></div><br/>');
  echo('Verze klienta použitá pro import: <strong>'.$Config['Web']['GameVersion'].'</strong>');
  $DbResult = $Database->SQLCommand('SELECT COUNT(*) FROM `Group`');
  $DbRow = mysql_fetch_row($DbResult);
  $PageList = GetPageList($DbRow[0]);  
  echo('<h3>Seznam překladových skupin</h3>');
  echo($PageList['Output']);
  
  echo('<table class="BaseTable">');
  $TableColumns = array(
    array('Name' => 'Name', 'Title' => 'Jméno'), 
    array('Name' => 'SourceType', 'Title' => 'Typ zdroje'), 
    array('Name' => 'SourceName', 'Title' => 'Jméno zdroje'), 
    array('Name' => 'LastImport', 'Title' => 'Datum'), 
    array('Name' => 'LastVersion', 'Title' => 'Verze'),
    array('Name' => '', 'Title' => 'Akce'), 
  );

  $Order = GetOrderTableHeader($TableColumns, 'Name', 0);
  echo($Order['Output']);

  $ID = $Database->SQLCommand('SELECT * FROM `Group`'.$Order['SQL'].$PageList['SQLLimit']);
  while($Group = mysql_fetch_assoc($ID)) 
  {
    echo('<tr><td>'.$Group['Name'].'</td><td>'.$Group['SourceType'].'</td><td>');
    if($Group['MangosTable'] != '') echo($Group['MangosTable'].'.sql ');
    if($Group['DBCFileName'] != '') echo($Group['DBCFileName'].'.dbc ');
    if($Group['LuaFileName'] != '') echo($Group['LuaFileName'].'.lua ');
    echo('</td><td><a title="Změny po posledním importu u vybrané překladové skupiny" href="log.php?group='.$Group['Id'].'&amp;type=11">'.HumanDate($Group['LastImport']).'</a></td><td>'.GetVersionWOW($Group['LastVersion']).'</td><td><a href="?action=importgroup&amp;id='.$Group['Id'].'">Importovat</a></td></tr>');
  }
  echo('</table>');
}

function UpdateTranslated()
{
  echo('<div style="font-size: xx-small;">');
  $Import = new Import();
  $Import->UpdateTranslated();
  echo('</div>');
}

if(array_key_exists('action', $_GET))
{
  if($_GET['action'] == 'instructions') ShowInstructions();
  else if($_GET['action'] == 'importgroup') ShowImportGroup();
  else if($_GET['action'] == 'update_translated') UpdateTranslated();
  else ShowMenu();                                           
} else ShowMenu();

ShowFooter();      

?>
